package com.roidapp.imagelib.facedetector

import jp.co.cyberagent.android.gpuimage.Rotation
import kotlinx.coroutines.CoroutineScope
import kotlinx.coroutines.Job

interface FaceDetectorInterface {

    fun start()
    fun resume()
    fun pause()
    fun stop(): Job
    fun setViewSize(width: Int, height: Int)
    fun isPaused(): Boolean
    suspend fun doFaceDetectionProcedure(scope: CoroutineScope)

    interface FaceDetectorCallback<T> {
        fun onLibraryLoaded()
        fun onStartDetection()
        fun onPauseDetection()
        fun onResumeDetection()
        fun onStopDetection()
        fun getCameraPixelArray(): ByteArray?
        fun isFrontCamera(): Boolean
        fun getDirection(): Int
        fun getRotation(): Rotation
        fun getCameraOrientation(): Int
        fun getDeviceOrientation(): Int
        fun onFaceDataUpdated(faceList: ArrayList<T>)
    }
}