package com.roidapp.imagelib.facedetector

import android.graphics.PointF
import android.graphics.RectF
import com.roidapp.imagelib.retouch.facetrack.FaceDetectLandmark

interface FaceStructProducerInterface<T> {

    fun produce(face: T): FaceStruct
    fun produceFaceDetectLandmark(face: T, width: Int, height: Int, orientation: Int): FaceDetectLandmark?

    data class FaceStruct(val points: Array<PointF>,
                          val keyPointValueArray: FloatArray,
                          val faceRect: RectF,
                          val compactFaceRect: RectF)
}