package com.roidapp.imagelib.filter

import com.roidapp.baselib.release.Resources.DEFAULT_UNKNOWN_PROGRESS
import java.util.concurrent.ConcurrentHashMap

sealed class ValueType{
    object INT: ValueType()
    object LONG: ValueType()
    object FLOAT: ValueType()
    object DOUBLE: ValueType()
}

class NumberValueHelper<R> {

    private val valueMap : ConcurrentHashMap<R, Number> = ConcurrentHashMap()
    private val typeMap : ConcurrentHashMap<R, ValueType> = ConcurrentHashMap()

    fun delcareValueType(type: R, clz: ValueType){
        typeMap[type] = clz
    }

    fun setFilterParamValue(type: R, value: Number) {

        val numType = typeMap[type] ?: ValueType.FLOAT
        val v2 : Number = when(numType){
            ValueType.INT -> value.toInt()
            ValueType.LONG -> value.toLong()
            ValueType.FLOAT -> value.toFloat()
            ValueType.DOUBLE -> value.toDouble()
        }
        valueMap[type] = v2

    }

    fun <T> getFilterParamValue(type: R): T {
        return if(valueMap[type] != null) valueMap[type] as T
                else {
                    DEFAULT_UNKNOWN_PROGRESS as T
                }
    }
}