package com.roidapp.imagelib.filter.producer.impl

import android.content.Context
import com.roidapp.imagelib.filter.filterinfo.CloudFilterInfo
import com.roidapp.imagelib.filter.producer.FilterProducerBase
import com.roidapp.imagelib.filter.producer.Params
import comroidapp.baselib.util.Logger
import jp.co.cyberagent.android.gpuimage.*
import java.util.ArrayList

class GlitchFilterProducer(private val mContext: Context,
                           private val mCfi: CloudFilterInfo) : FilterProducerBase() {

    override fun produceFilter(params: Params): List<GPUImageFilter>? {
        val filters = ArrayList<GPUImageFilter>()

        val glitchDirection = mCfi.extra.getString(CloudFilterInfo.Keys.GLITCH_DIRECTION, "1").toInt()
        val glitchColorMode = mCfi.extra.getString(CloudFilterInfo.Keys.GLITCH_COLOR_MODE, "1").toInt()

        if (Logger.ENABLE_LOG) {
            Logger.d("produceFilter() called by id " + mCfi.id + " with:" +
                    " name = [" + mCfi.mName + "], " +
                    " glitch_direction = [" + glitchDirection + "]" +
                    " glitch_color_mode = [" + glitchColorMode + "]")
        }

        val glitchFilter = GPUImageGlitchFilter(glitchDirection, glitchColorMode)

        filters.add(glitchFilter)
        return filters
    }
}