package jp.co.cyberagent.android.gpuimage

class GPUImageColorComboFilter : GPUImageFilterGroup {

    private val colorFilter: GPUImageColorFilter
    private val sharpenFilter: GPUImageSharpenFilter

    constructor() : this (0.0f, 1.0f, 1.0f, 90.0f, 0.0f)
    constructor(brightness: Float, contrast: Float, saturation: Float, hue: Float, sharpness: Float) {
        colorFilter = GPUImageColorFilter(brightness, contrast, saturation, hue)
        sharpenFilter = GPUImageSharpenFilter(sharpness)
        addFilter(colorFilter)
        addFilter(sharpenFilter)
    }

    fun setBrightness(brightness: Float) { colorFilter.setBrightness(brightness) }
    fun setContrast(contrast: Float) { colorFilter.setContrast(contrast) }
    fun setSaturation(saturation: Float) { colorFilter.setSaturation(saturation) }
    fun setHue(hue: Float) { colorFilter.setHue(hue) }
    fun setSharpness(sharpness: Float) { sharpenFilter.setSharpness(sharpness) }
}