package jp.co.cyberagent.android.gpuimage


import android.opengl.GLES20

class GPUImageGlitch3Filter(GLITCH2_FRAGMENT_SHADER: String) : GPUImageFilter(NO_FILTER_VERTEX_SHADER, GLITCH2_FRAGMENT_SHADER) {

    val TAG = "Glitch3"
    private var colorModeLocation: Int? = null
    private var offsetLocation: Int? = null

    var mOffset: Float = 0.0f

    var colorMode: Int = 0
        set(value) {
            field = value
            colorModeLocation?.run {
                setInteger(this, value)
            }
        }

    init {
        colorMode = 2
        mOffset = 0.0f
    }

    override fun onInit() {
        super.onInit()
        colorModeLocation = GLES20.glGetUniformLocation(program, "colorMode")
        offsetLocation = GLES20.glGetUniformLocation(program, "offset")
    }

    override fun onInitialized() {
        super.onInitialized()
        colorMode = colorMode
        setOffset(mOffset)
    }

    fun setOffset(offset: Float) {
        mOffset = offset
        offsetLocation?.run { setFloat(this, mOffset) }

    }
}
